normalizePlateMedian = function(x, transform, zscore){
  if(!x$state["configured"])
    stop("Please configure 'x' (using the function 'configure.cellHTS') before normalization.")
  
  xn = array(as.numeric(NA), dim=dim(x$xraw))
  nrWpP = dim(x$xraw)[1]
  for(p in 1:(dim(x$xraw)[2])) {
    samples = (x$wellAnno[(1:nrWpP)+nrWpP*(p-1)]=="sample")
    for(r in 1:(dim(x$xraw)[3]))
      for(ch in 1:(dim(x$xraw)[4]))
        xn[, p, r, ch] = x$xraw[, p, r, ch] / median(x$xraw[samples, p, r, ch], na.rm=TRUE)
  }

  one = 1
  if(!missing(transform)) {
    xn = transform(xn)
    one = transform(one)
  }


  x$xnorm = xn

  ## calculates the z-score for each replicate separately
  if(!missing(zscore)) x$xnorm = calcZscores(x, one=one, sign=zscore)

  x$state["normalized"] = TRUE
  return(x)
}